#!/bin/sh

if [ $# -ne 1 ]; then
    echo 1>&2 "Usage:   $0 period"
    echo 1>&2 "Example: $0 200201-200206"
    exit 1;
fi

(echo "User hours jobs"; echo "---- ----- ----") | \
	awk '{printf "%-10s %-10s %s\n", $1, $2, $3}'

./accounting $1 logs/* 2>/dev/null | \
	grep "^	" | sort -nk2 | \
	awk '{printf "%-10s %-10.0f %d\n", $1, $2/3600+0.5, $3}'
