#!/bin/sh
#
# This shell script is called by accounting.awk
#

jobid=${1%%\.*}
shift

user=unknown		# Username
jobname=unknown		# Jobname
queue=unknown		# Queue
wall=0			# Wall time
np=0			# Nbr of nodes
for i in $*; do
    case $i in
	user=*)
	    user="${i##*=}"
	    ;;
	jobname=*)
	    jobname="${i##*=}"
	    ;;
	queue=*)
	    queue="${i##*=}"
	    ;;
	exec_host=*)
	    np="`echo ${i##*=} | sed -e 's/+/ /g' | wc -w | awk '{print $1}'`"
	    ;;
	resources_used.walltime=*)
	    wall="`echo ${i##*=} | \
		awk -F: '{printf "(%s*3600+%s*60+%s)",$1,$2,$3}'`"
	    ;;
    esac
done
echo $jobid $user $np `echo "$np*$wall" | bc` | \
	awk '{printf "%-10s %-10s %-8s %s\n", $1, $2, $3, $4}'
