#!/bin/bash

[ -n "$MANPATH" ] || export MANPATH=":"

add_path () {
    echo "$PATH" | grep -qw $1 && return
    export PATH=${PATH}:$1
}

add_man_path () {
    echo "$MANPATH" | grep -qw $1 && return
    export MANPATH=${MANPATH}:$1
}

#export CC=gcc
export F77=ifc

add_path /usr/local/pbs/bin:/usr/local/maui/bin
add_man_path /usr/local/pbs/man

add_path /opt/intel/compiler60/ia32/bin
add_man_path /opt/intel/compiler60/man

add_man_path /usr/local/pgi/man

if [ ! -n "$PVM_ROOT" ]; then
    export PVM_ROOT=/usr/local/pvm
    export PVM_ARCH="LINUXGM"
    export PATH=${PATH}:${PVM_ROOT}/lib/${PVM_ARCH}:${PVM_ROOT}/lib
    export MANPATH=${MANPATH}:${PVM_ROOT}/man
fi

	#add_path /usr/local/lam-mpi/bin

if [ -O /bin/su ]; then
    # special settings for root
    add_path /sbin:/usr/sbin
    add_path /usr/local/pbs/sbin:/usr/local/sbin:/usr/local/maui/sbin
    umask 077
else
    # special settings for non-root users
    export PATH=.:${PATH}
fi

alias passwd="yppasswd"
alias ls="ls --color=tty"
alias rm="rm -i"
alias cp="cp -i"
alias mv="mv -i"

#export ETTERM=linux-console
export ETTICKS=5

[ "$PS1" = "\\s-\\v\\\$ " ] && PS1="[\u@\h \W]\\$ "

export PGI=/usr/local/pgi
ulimit -f 4194303
