#!/bin/bash
#
# chkconfig: 345 99 01
# description: Load GM module
# processname:

# source function library
. /etc/rc.d/init.d/functions

RETVAL=0

case "$1" in
  start)
	cd /usr/local/gm
	#sh ./GM_INSTALL
	echo -n "Load gm module: "
	/sbin/insmod /usr/local/gm/sbin/gm
	#echo -n "Starting GM (static) mapper: "
	#/bin/dmesg | tail -10
	#cd /usr/local/gm/sbin/
        #./file_mapper file.args
	RETVAL=$?
	echo
	[ $RETVAL -eq 0 ] && touch /var/lock/subsys/gm
	;;
  stop)
	echo -n "Unload gm module: "
	/sbin/rmmod gm
	RETVAL=$?
	[ $RETVAL -eq 0 ] && rm -f /var/lock/subsys/gm
	echo
	;;
  status)
	/sbin/lsmod | grep "^gm "
	RETVAL=$?
	;;
  restart|reload)
	$0 stop
	$0 start
	RETVAL=$?
	;;
  map)
	cd /usr/local/gm/sbin/
        ./file_mapper file.args
	RETVAL=$?
	;;
  *)
	echo "Usage: $0 {start|stop|status|restart|reload|map}"
	exit 1
esac

exit $RETVAL
