/* : н֮ Sendrecv 
 * 㷨ݹηְѭ㷨, ҪԼ p-1+lgp 
 *
 * ÷: mpirun -np 4 gm_check 4m 1000	(ݿСȡ 4MB, timeout Ϊ 1s)
 * */

#define ENABLE_TIMEOUT

#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <string.h>
#include <unistd.h>
#include <mpi.h>

static unsigned int timeout = 0;
static size_t size = 0;
static int nprocs, myrank;
static char *sendbuf, *recvbuf;

typedef char name_t[MPI_MAX_PROCESSOR_NAME + 1];
static name_t *names, myname;

static int verbose = 0;

static void
p2p(int peer)
{
    double time;
    int i, j, count, completed, cancelled, flag;
    MPI_Request req[2];
    MPI_Status status;
    
    cancelled = 0;
    for (j = 0; j < 2 && !cancelled; j++) {
	/* pass 1: small message for sync., pass 2: real message for timing */
	int size1 = j ? size : 1;
	time = MPI_Wtime();
	MPI_Isend(sendbuf, size1, MPI_BYTE, peer, 1, MPI_COMM_WORLD, req + 0);
	MPI_Irecv(recvbuf, size1, MPI_BYTE, peer, 1, MPI_COMM_WORLD, req + 1);
	count = completed = 0;
	while (1) {
            if (timeout && count++ >= timeout) {
		for (i = 0; i < 2; i++)
		    if (req[i] != MPI_REQUEST_NULL) MPI_Cancel(req + i);
		cancelled = 1;
		break;
	    }
	    for (i = 0; i < 2; i++) {
		if (req[i] != MPI_REQUEST_NULL) {
		    MPI_Test(req + i, &flag, &status);
		    if (flag) {
			completed++;
			MPI_Wait(req + i, &status);
			req[i] = MPI_REQUEST_NULL;
		    }
		}
	    }
	    if (completed == 2) break;
	    usleep(10000);
	}
	time = MPI_Wtime() - time;
    }
    
    if (myrank < peer) {
	if (cancelled)
	    fprintf(stderr, "%03d [%s] <==> %03d [%s]: error in pass %d of 2\n",
			myrank, names[myrank], peer, names[peer], j);
	else if (verbose)
	    fprintf(stderr, "%03d [%s] <==> %03d [%s]: %0.2lf MB/s\n",
			myrank, names[myrank], peer, names[peer],
			1e-6 * (size * 2.0) / (time + 1e-9));
	fflush(stderr);
    }
}

static void
recursion(int rank0, int np)
{
    int np2 = np / 2, rank1 = rank0 + np2, rank2 = rank0 + np;
    int j, j0;

    if (np <= 1 || myrank >= np + rank0 || myrank < rank0)
	return;

    if (myrank < rank1) {
	j0 = j = myrank + (rank1 - rank0);
	do {
	    p2p(j);
	    if (--j < rank1) j = rank2 - 1;
	} while (j != j0);
    }
    else {
	j0 = j = myrank - (rank1 - rank0);
	do {
	    if (j < rank1) p2p(j);
	    if (++j >= rank0 + rank2 - rank1) j = rank0;
	} while (j != j0);
    }

    /* recursion */
    recursion(rank0, rank1 - rank0);
    recursion(rank1, rank2 - rank1);
}

int
main(int argc, char **argv)
{
    int i;
    double time0, time1;
    char *p;

    /* ʼ MPI  */
    MPI_Init(&argc, &argv);
    MPI_Comm_size(MPI_COMM_WORLD, &nprocs);
    MPI_Comm_rank(MPI_COMM_WORLD, &myrank);
    MPI_Get_processor_name(myname, &i);
    myname[i] = '\0';
    if ((p = strchr(myname, '.')) != NULL) *p = '\0';

    MPI_Errhandler_set(MPI_COMM_WORLD, MPI_ERRORS_RETURN);

    /* ȡв */
    if (argc != 3 && argc != 4) {
	if (myrank == 0) {
	    fprintf(stderr, "Usage: %s <buffersize[K|M|G]> <timeout> "
			    "[verbose]\n", argv[0]);
	    fprintf(stderr, "Example: %s 1m 10 verbose\n", argv[0]);
	}
	MPI_Finalize();
	exit(1);
    }

    size = strtol(argv[1], &p, 10);
    switch (toupper(*p)) {
	case 'G':
	    size *= 1024;
	case 'M':
	    size *= 1024;
	case 'K':
	    size *= 1024;
	    break;
    }
    timeout = strtol(argv[2], &p, 10);
    if (argc > 3 && !strcmp(argv[3], "verbose"))
	verbose = 1;

    if (size <= 0) {
	fprintf(stderr, "Process %d: invalid size %d\n", myrank, size);
	MPI_Abort(MPI_COMM_WORLD, 1);
    }

    if (myrank == 0)
	fprintf(stderr, "Buffer size: %d bytes, timeout: %0.2lf second%c\n",
			size, timeout * 0.01, timeout > 100 ? 's' : ' ');

    /* ڴ */
    if ((sendbuf = malloc(size)) == NULL || (recvbuf = malloc(size)) == NULL
		|| (names = malloc(nprocs * sizeof(*names))) == NULL) {
	fprintf(stderr, "Process %d: memory allocation error!\n", myrank);
	MPI_Abort(MPI_COMM_WORLD, 1);
    }

    /* õн */
#if 1
    MPI_Allgather(myname, sizeof(*names), MPI_CHAR,
		  names,  sizeof(*names), MPI_CHAR, MPI_COMM_WORLD);
#else
    for (i = 0; i < nprocs; i++)
	strcpy(names[i], i == myrank ? myname : "?????");
#endif
    
    /* ͻֵ */
    memset(sendbuf, myrank, size);

    MPI_Barrier(MPI_COMM_WORLD);
    time0 = MPI_Wtime();
    recursion(0, nprocs);
    MPI_Barrier(MPI_COMM_WORLD);
    time1 = MPI_Wtime();
    if (myrank == 0)
	fprintf(stderr, "Wall time = %lf\n", time1 - time0);

    MPI_Finalize();
    return 0;
}
